clear
clc

% **************************************************************************************************************


%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$
                     
                                    latitude_injection= 70;                                      % En degrs

%                                $$$$$$$$$$$$$$$$$$$$$$$$$$$$

% **************************************************************************************************************

global Ir It Il Irl Itl Irt Asat etat_init vitesse_rotation altitude points_trace tau vitesse_angul_mini
global instant_injection T Ta Tu pulse periode vit_ang_max_pert angle_max_pert vitesseroue
global temps_init_pert init_pert K_poinsot


%  *****************  SURVEILLANCE DU MODE LIBRE SOUS PERTURBATIONS *****************

vit_ang_max_pert=5*pi/180 ;      % Vitesse angulaire au dessus de laquelle on revient au mode fin, aprs le rgime libre
                                 % uniquement soumis aux perturbations
angle_max_pert=5*pi/180;         % Angle maximum d'cart en dpointage ( pour la prise de vue) 

% ************************* RECUPERATION DES VALEURS FINALES ************************

% Elles viennent de regdesat.m et sont dans le fichier fin2pert.mat  de la variable modfin2pert
%  8 composantes
	% Le quaternion de 1  7
	% Le temps final en 8

% Elles sont rcuprables dans l'espace MATLAB en lanant $$$->>    AApert0.m   $$$$$

load init_pert.mat;                                      % Chargement du fichier

temps_init_pert=totale2pert(1,length(totale2pert));     % Rcupration du temps

init_pert=totale2pert(2:8,length(totale2pert));         % Rcupration de p q r Q

init_pert=init_pert';                                   % En ligne horizontale

load vit_roue.mat;

vitesseroue=vit_roue_rd_s(2,length(vit_roue_rd_s));

% ***********************************************************************************

K_poinsot=1;              % Permet par la mise  0 de simuler un mouvement de poinsot, sans moment externe
                          % ce qui permet de vrifier une bonne partie de la simulation ( intgration)

% Gain de la matrice de gain pour la drive de B

% Constante de temps 

 tau=200;

% Nombre de points du trac

 points_trace=30000;

% Ce fichier initialise la simulation regderiv.m ou regdesat.m ou reg_derb.m

% Matrice d''inertie satellite

Ir=32e-3;It=36e-3;Il=22e-3;Irt=5.8e-5;Irl=3e-4;Itl=4e-3;

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

latitude_injection=latitude_injection*pi/180;                          % 70 convertis en rd

instant_injection=asin(sin( latitude_injection)/sin(inclinaison))/vitesse_rotation;
 
instant_injection=fix(instant_injection);              % Instant injection calcul  1 seconde prs
                                                       % aprs survol quateur suppos  t=0 seconde


                             %   **********  VALEURS INITIALES   ******

% Initialisation en vitesses (rd/s)

v_roulis0=0.0001;
v_tangage0=-0.0002;                        % Valeurs moyennes
v_lacet0=0.0003;

% Initialisation en position (rd)

roulis0=1*pi/180;
tangage0=-0.2*pi/180;
lacet0=1*pi/180;

                             % ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;

% **********************************************************************

                            % ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end







