function y=pqrQ_V_P(u);

global vitesse_rotation

% Fonction qui extrait :
%	les drives des angles de Cardan
%	les angles de Cardan du repre satellite par rapport au repre orbital
% du vecteur d'entre u  7 composantes
%	de 1  3 p q r composantes absolues du satellite exprimes en repre orbital XYZ
%	de 4  7 les 4 composantes du quaternion d'attitude du satellite xyz par rapport
%	au repre orbital XYZ

% ------------------------------  But ----------------------------

% Eviter les problmes de drives avec sauts dans les PD ou PID

% ----------------------------------------------------------------


% ********************* DEBUT PROGRAMME  ************************

omega_abs=u(1:3);  

Q=u(4:7);

q0=Q(1);q1=Q(2);q2=Q(3);q3=Q(4);

% Extraction des angles en radian

phi=atan2(2*(q0*q1+q2*q3),q0^2-q1^2-q2^2+q3^2);

teta=asin(2*(q0*q2-q1*q3));

psi=atan2(2*(q0*q3+q2*q1),q0^2+q1^2-q2^2-q3^2);

angles_colonne=[phi teta psi]';

% Sortie vecteur colonne roulis tangage lacet


% Calcul de la matrice de passage de XYZ  xyz


Pmat=passage(Q);

% Calcul des composantes de Y sur les axes satellite xyz, ceci pour transformer
% la rotation orbitale woY dans xyz

rotation_orbitale=Pmat*[0 vitesse_rotation 0]';


% Calcul de la matrice de changement d'axes de mesure des angles de Cardan vers xyz ( elle
% n'est unitaire et prsente une difficult pour tangage = + ou - 90

% D'o la prcaution suivante qui ne faussera les calculs que sur un court instant
% lorsque cos(tangage) approche 0 on donne des valeurs plausibles mais inefficaces 
% pratiquement nulles

 if abs(cos(teta))>0.001

          Pcardan=mat_card(angles_colonne);
 else 

          Pcardan=eye(3)*1000;

 end

% Calcul des vitesses phi' teta' psi' en colonne

vitesses_colonne=inv(Pcardan)*( omega_abs-rotation_orbitale);


% Sortie d'un vecteur colonne  6 composantes:
%	De 1  3 les angles de Cardan en rd
%	De 4  6 les vitesses angulaires drives des angles de Cardan	


y(1:3)=angles_colonne;

y(4:6)=vitesses_colonne;

y=y';  % Sortie ligne

end

% -------------------------------------- Fin programme  -----------------------------



