%                                 SIMULATION NANOSATELLITE MISSION CASAASAT
%                                 *****************************************                                                                                                  
%
%                              SIMULATION SANS QUATERNION PAR TMC petits mouvements
%                                  
%                                 *****************************************
% clear
% clc
% hold off
% clg
casesen on;

global vitesseroue reponse init_tmc temps_init_tmc vit_ang_max_acqf angle_max_acqf desat vit_roue_max

global moment_max_bobine couple_max_roue

% ********************************* Conditions d'arrt du mode fin ***********************

vit_ang_max_acqf=3*pi/180;      %  Arrt simultan    
angle_max_acqf=1*pi/180;        % et 1 de pointage

coupure_gain=1;                 % Stop arm

% *****************************************************************************************


 moment_max_bobine=0.2;      % Am  puissance maxi d'une bobine
 cpl_max_roue=4e-6;          % Nm   couple maxi dlivr par la roue

% ******************************************************************************************



% Matrice d''inertie satellite

Ir=32e-3;It=36e-3;Il=22e-3;Irt=5.8e-5*0;Irl=3e-4*0;Itl=4e-3;

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Caractristiques de l'orbite du satellite

altitude_orbite=817;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=98.7*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

 % ********************Calculs annexes*************************

 K=vitesse_rotation^2;

 DER=[Asat(1,1) 0 0 ;
           0 Asat(2,2) 0;
              0 0 Asat(3,3)];

 PAR=[4*(Asat(2,2)-Asat(3,3)) 0 0;
          0 3*(Asat(1,1)-Asat(3,3)) 0;
             0 0 (Asat(2,2)-Asat(1,1))]*K;              % /seconde


 % ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;
cpl_aero3=0;





tsim=periode_orbitale;  % 6074 C'est la priode de l'orbite

points_trace=30000;




J=3.2e-5;  % Moment d'inertie de la roue en mkg
J_ROUE=3.2e-5;


% Matrices(3X3) servant  calculer la matrice(3X3) N_SAT=K_SAT+w*H_SAT
% wo fourni par totdat.m et w variable recueilli en cours de simulation

K_SAT=vitesse_rotation*[0 2*Itl (Ir+Il-It);
         -2*Itl 0 2*Irt;
            -(Ir+Il-It) -2*Irt 0];

H_SAT=[0 0 -1;
         0 0 0;
           1 0 0]*J_ROUE;  % Cette matrice devra tre multiplie par w = vitesse roue

% Elements de la matrice P_SAT= L_SAT+Q_SAT*w

% Matrices(3X3) servant  calculer la matrice(3X3) P
% wo fourni par totdat.m et w variable recueilli en cours de simulatio

L_SAT=[4*(It-Il) 3*Irt -Irl;
              4*Irt 3*(Ir-Il) Itl;
                      -4*Irl -3*Itl (It-Ir)]*vitesse_rotation^2;

Q_SAT=[1 0 0;
         0 0 0;
           0 0 1]*J_ROUE*vitesse_rotation;



% -----CEUX DU TANGAGE-----( roue, vitesse max, PID, temps de retard,.. reprise de scaodat9.m

%                SIMULATION DE DESATURATION AVEC COMMANDE P & D DE LA ROUE 

   




 teta_zero=5*pi/180;    % Position initiale en radian 

 teta_prim0=0;          % vitesse initiale en rd/s
 
 consigne_tangage=0.1;  %   Valeur de consigne de l'angle de tangage  atteindre, en radian 
 
 retard1=0.5;           %   Retard en secondes de la mesure de la position

 retard2=0.2;           %   Retard en secondes de la mesure de la vitesse

 omega2=3*vitesse_rotation^2*(Ir-Il)/It;   % Carr de la pulsation de tangage due au gradient de gravit

%-----------------------------------

 vitesseroue=-360*0;

 
 Ti=1e-3;           % Constante de temps de l'intgrateur

 Td =2;             % Constante de temps de chane drive

 N=6;               % Entier ou pas  choisir entre 3 et 10 classiquement

 retard3=1;         % Retard de raction de la roue

 rotation_initiale= -330;    % Vitesse de rotation initiale de la roue  3900 t/mn

 rotation_maximale= 360;    % Vitesse de rotation maximale de la roue 3600 t/mn



%-----------------------------------

 
 K_PD=220e-7;  %   Gain proportionnel
 F_PD=5*7.5e-4;    %   Gain amortissement drive

 I_PD=1e-10;     %   Gain intgrateur non utilis

 gain_roue=10;




gain=[250000 0 0 2500 0 0;
                 0 15000 0 0 14 0;
                       0 0 50000 0 0 75];

gain=[50000 0 0 25 0 0;
                 0 45000 0 0 14 0;
                       0 0 1000000 0 0 1500]*2.5e-5;
gain=[1e-6 0 0 6e-7 0 0;
           0 2e-6 0 0 3e-6 0;
             0 0 4e-6 0 0 1.8e-6];



 cpl_aero1=0;cpl_aero2=3.63e-8;cpl_aero3=0;  % COUPLE AERODYNAMIQUE

 cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

  
% Matrices(3X3) servant  calculer la matrice(3X3) N_SAT=K_SAT+w*H_SAT
% wo fourni par totdat.m et w variable recueilli en cours de simulation

K_SAT=vitesse_rotation*[0 2*Itl (Ir+Il-It);
         -2*Itl 0 2*Irt;
            -(Ir+Il-It) -2*Irt 0];

H_SAT=[0 0 -1;
         0 0 0;
           1 0 0]*J_ROUE;  % Cette matrice devra tre multiplie par w = vitesse roue

% Elements de la matrice P_SAT= L_SAT+Q_SAT*w

% Matrices(3X3) servant  calculer la matrice(3X3) P
% wo fourni par totdat.m et w variable recueilli en cours de simulatio

L_SAT=[4*(It-Il) 3*Irt -Irl;
              4*Irt 3*(Ir-Il) Itl;
                      -4*Irl -3*Itl (It-Ir)]*vitesse_rotation^2;

Q_SAT=[1 0 0;
         0 0 0;
           0 0 1]*J_ROUE*vitesse_rotation;


% -----CEUX DU TANGAGE-----( roue, vitesse max, PID, temps de retard,.. reprise de scaodat9.m

%                SIMULATION DE DESATURATION AVEC COMMANDE P & D DE LA ROUE 




 teta_zero=5*pi/180;    % Position initiale en radian

 teta_prim0=0;          % vitesse initiale en rd/s

%  *******************************  CONSIGNES   ************************* 

 consigne_tangage=0;  %   Valeur de consigne de l'angle de tangage  atteindre, en radian 
 consigne_roulis=-0;
 consigne_lacet=0;

%  *********************************   RETARDS  ***********************

 
 retard1=0.5;           %   Retard en secondes de la mesure de la position

 retard2=0.2;           %   Retard en secondes de la mesure de la vitesse

 omega2=3*vitesse_rotation^2*(Ir-Il)/It;   % Carr de la pulsation de tangage due au gradient de gravit

%-----------------------------------


 
 K_PID=47e-7;       %   Gain proportionnel
 F_PID=3e-4;    %   Gain amortissement drive
 I_PID=1e-8;     %   Gain intgrateur
 gain_tangage=1e5;


 
 K_PID_ROULIS=2.8e-6;  %   Gain proportionnel
 F_PID_ROULIS=3e-5;    %   Gain amortissement drive
 I_PID_ROULIS=1e-8;     %   Gain intgrateur
 
 gain_roulis=5;


 
 K_PID_LACET=4.7e-5;  %   Gain proportionnel
 F_PID_LACET=3e-4;    %   Gain amortissement drive
 I_PID_LACET=2e-8;     %   Gain intgrateur

 gain_lacet=0.25;



 gain_desaturation = 8e3;   % Gain de la desaturation  appliquer aux bobines roulis et lacet

 desat_en_cours=0;

 stop=0;arret=0;

 debut_desaturation=800;

 temps=0;  % Initialisation de la variable temps pour la fonction stop_des.m



 cpl_aero1=0;cpl_aero2=3.63e-8;cpl_aero3=0;  % COUPLE AERODYNAMIQUE

 cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

desat=0;

%reponse=input('**** QUESTION?? ****  Desirez-vous simuler une dsaturation (1/0): ','s');
% reponse est envoy dand l'espace Matlab lors du choix dsaturation ou pas

 if reponse==1,

  desat=1;

 else

 desat=0;

end

% La vitesse initiale de la roue est adapte  la rponse

 rotation_initiale= rotation_initiale*(1-desat)-(rotation_maximale+10)*desat;    % Vitesse de rotation initiale de la roue  3900 t/mn

 vitesse_roue=rotation_initiale;

% Valeur maximale accepte pour les angles, permettant l'arrt de la rgulation, hors dsaturation

 angle_arret=0.5;  % Donner en degrs et pas en radian
 
vit_roue_max=6000;

% $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

                             %   **********  VALEURS INITIALES   ******

% Initialisation en vitesses (rd/s)

v_roulis0=0.002;
v_tangage0=0.003;                        % Valeurs moyennes
v_lacet0=0.001;

% Initialisation en position (rd)

roulis0=0.01;
tangage0=-0.15;
lacet0=0.05;



                            % ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

% etat_init_tmc=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; Si la simulation se reprenait en quaternion


% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

etat_init_tmc=[v_roulis0 v_tangage0 v_lacet0 roulis0 tangage0 lacet0];

end


